//---------------------------------------------------------------------------
// TuScopa v0.047 (Stegh Traibaj & Tludet Dejouga Eldoeu j Pirlunsteset)
// Copyleft 1998 ACME Inc (ex Tugomira Soft)
//---------------------------------------------------------------------------
// file principale del motore Ai: tuscopa.cpp
//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include <dos.h>
// DEB printf in euristica e distribuisci non ci devono essere nella versione
// DEB finale
#include <stdio.h>

#pragma hdrstop

#include "stocasti.h"
#include "tuscopa.h"

//---------------------------------------------------------------------------
const int  comb[11][4][3]  =
	{
		{{0,0,0}, {0,0,0}, {0,0,0},{0,0,0}},
        {{0,0,0}, {0,0,0}, {0,0,0},{0,0,0}},
        {{2,0,0}, {0,0,0}, {0,0,0},{0,0,0}},
        {{3,0,0}, {0,0,0}, {0,0,0},{0,0,0}},
        {{4,0,0}, {0,0,0}, {0,0,0},{0,0,0}},
        {{2,3,0}, {0,0,0}, {0,0,0},{0,0,0}},
        {{2,4,0}, {0,0,0}, {0,0,0},{0,0,0}},
        {{2,5,0}, {3,4,0}, {0,0,0},{0,0,0}},
        {{2,6,0}, {3,5,0}, {0,0,0},{0,0,0}},
        {{2,7,0}, {3,6,0}, {2,3,4},{4,5,0}},
        {{2,8,0}, {3,7,0}, {2,3,5},{4,6,0}},
	};
// numero di possibilita per ogni valore della carta poggiata
const int numpos[11] =
    {0,0,1,1,1,1,1,2,2,4,4};

// numero di carte a terra impegnate per ogni valore carta poggiata
// e per ogni possibilita con quella carta poggiata
const int numimp[11][4] =
  {
   {0,0,0,0},
   {0,0,0,0},
   {1,0,0,0},
   {1,0,0,0},
   {1,0,0,0},
   {2,0,0,0},
   {2,0,0,0},
   {2,2,0,0},
   {2,2,0,0},
   {2,2,3,2},
   {2,2,3,2}
  };


// valore primiera per ogni carta
const int valprim[11] =
{0,16,12,13,14,15,18,21,10,10,10};
// ordinamento dei valori primiera
const int ordprim[11] =
{0,10,9,8,2,3,4,5,1,6,7};

//---------------------------------------------------------------------------
// Variabili Globali
Stato oras;             // stato di gioco
AGruppo tuttelecarte;   // stato (carte ancora in mano)
Risultato ris;          // carta scelta ed eventuale presa e valore
//---------------------------------------------------------------------------
// inizializza un gruppo di carte
void initgruppo(Gruppo *g)
{
 int i,j;
 for (i=0; i<11; i++)
 {
  g->quanti[i] = 0;
  for (j=0; j<4; j++)
  {
   	g->info[i][j].edentro = 0;
    g->info[i][j].cera = 0;
    g->info[i][j].chi = 0;
    g->info[i][j].quandoin = 0;
    g->info[i][j].somma = 0;
  }
 }
 g->tot = 0;
}
//---------------------------------------------------------------------------
// somma i valori (in terra ad esempio)
int sommavalori(const Gruppo *gruppo)
{
 int i,c;
 if (gruppo->tot == 0)
 	return 0;
 else for (i=ASSO,c=0; i<=RE; i++)
 	c += gruppo->quanti[i]*i;
 return c;
}
//---------------------------------------------------------------------------
// vero se il gruppo di carte non ne contiene
bool evuoto(const Gruppo *g)
{
 return g->tot == 0;
}
//---------------------------------------------------------------------------
// aggiunge una carta ad un gruppo di carte
void mettistoriacarta(int chi,int quando,int somma, Carta c, const Gruppo *g)
{
 assert(c.valore>0 && c.valore<11);   //DEB
 assert(chi >=0 && chi<4);            //DEB
 assert(quando>=0 && quando<40);      //DEB
 assert(somma <= 55);                 //DEB

 g->info[c.valore][c.seme].chi = chi;
 g->info[c.valore][c.seme].quandoin = quando;
 g->info[c.valore][c.seme].somma = somma;
}
//---------------------------------------------------------------------------
// aggiunge una carta ad un gruppo di carte
void _mettistoriacarta(int chi,int quando,int somma,
						int valore,int seme, const Gruppo *g)
{
 assert(valore>0 && valore<11);       //DEB
 assert(chi >=0 && chi<4);            //DEB
 assert(quando>=0 && quando<40);      //DEB
 assert(somma <= 55);                 //DEB

 g->info[valore][seme].chi = chi;
 g->info[valore][seme].quandoin = quando;
 g->info[valore][seme].somma = somma;
}
//---------------------------------------------------------------------------
// metti gruppi di carte in altri gruppi di carte
// DEB puo usare primacarta proxcarta (se  piu veloce)
void mettigruppo(const Gruppo *source,Gruppo *dest)
{
 int
  v,s;

 assert(source->tot >= 0);
 if (source->tot == 0) return;
 dest->tot += source->tot;
 assert(dest->tot < 41); //DEB indicazione di massima
 for (v = ASSO; v<= RE; v++)
 {
  if (source->quanti[v] > 0)
  {
   dest->quanti[v] += source->quanti[v];
   for (s = 0; s<4; s++)
   {
    //DEB non vero che metto qualcosa se c'e gia
    assert(!(source->info[v][s].edentro && dest->info[v][s].edentro));
    dest->info[v][s].edentro = source->info[v][s].edentro ||
    							dest->info[v][s].edentro;
    if (dest->info[v][s].edentro)  // DEB utilizzare questo if anche sopra
        dest->info[v][s].cera = true; // c'e stata
   }
  } 
 }
}

//---------------------------------------------------------------------------
// metti gruppi di carte in altri gruppi di carte
// aggiornando la storia delle carte
// DEB puo usare primacarta proxcarta (se  piu veloce)
// DEB unificare con mettigruppo
// DEB gruppo dovrebbe memorizzare il valore della prima questa dovrebbe
// DEB utilizzare tot per accorgersi che le carte sono finite
void mettistoriagruppo(int chi,int quando,int somma,
						const Gruppo *source,Gruppo *dest)
{
 int
  v,s;

 assert(source->tot >= 0);   	// DEB
 if (evuoto(source)) return; 	// DEB
 dest->tot += source->tot;
 assert(dest->tot < 41); 		//DEB indicazione di massima
 for (v = ASSO; v <= RE; v++)
 {
  if (source->quanti[v] > 0)
  {
   dest->quanti[v] += source->quanti[v];
   for (s = 0; s<4; s++)
   {
    //DEB non vero che metto qualcosa se c'e gia
    assert(!(source->info[v][s].edentro && dest->info[v][s].edentro));
    dest->info[v][s].edentro = source->info[v][s].edentro ||
    							dest->info[v][s].edentro;
    if (source->info[v][s].edentro)
    {
     dest->info[v][s].cera = true; // c'e stata
     _mettistoriacarta(chi,quando,somma,v,s,dest);
    }
   }
  }
 }
}
//---------------------------------------------------------------------------
// togli un gruppo di carte da un'altro gruppo di carte
void togligruppo(const Gruppo *source,Gruppo *dest)
{
 int
  val,sem;

 assert(source->tot > 0 && dest->tot > 0);  //DEB
 dest->tot -= source->tot;
 assert(dest->tot >= 0);                    //DEB
 for (val = 1; val<11; val++)
 {
  if (source->quanti[val] > 0)
  {
   dest->quanti[val] -= source->quanti[val];
   for (sem = 0; sem<4; sem++)
   {
    // non vero che tolgo se non c'e
    assert(!(source->info[val][sem].edentro &&
    			!(dest->info[val][sem].edentro))); //DEB
    dest->info[val][sem].edentro = !(source->info[val][sem].edentro) &&
    							dest->info[val][sem].edentro;
   }
  }
 }
}
//---------------------------------------------------------------------------
// aggiunge una carta ad un gruppo di carte
void metticarta(const Carta c, Gruppo *g)
{
 assert(c.valore>0 && c.valore<11);
 assert(g->quanti[c.valore]<4);

 g->quanti[c.valore]++;
 assert(g->info[c.valore][c.seme].edentro == false);
 g->info[c.valore][c.seme].edentro = true;
 g->info[c.valore][c.seme].cera = true;			// c'e stata
 g->tot++;
}
//---------------------------------------------------------------------------
// rimuove una carta da un gruppo di  carte
void toglicarta(const Carta c, Gruppo *g)
{
 assert(g->quanti[c.valore]>0);
 g->quanti[c.valore]--;
 assert(g->info[c.valore][c.seme].edentro == true);
 g->info[c.valore][c.seme].edentro = false;
  g->tot--;
}
//---------------------------------------------------------------------------
// costruisce una carta
void setcarta(int valore, int seme, Carta *c)
{
 c->valore = valore;
 c->seme = seme;
}
//---------------------------------------------------------------------------
// aggiorna statistiche prendendo in input solo una carta
void aggiornastatcarta(int squadra,int valore,int seme, Stato *ora)
{
 Stat *stat = &(ora->stat[squadra]),
      *astat = &(ora->stat[avversario(squadra)]);
 int i,a;

 // conta ori fatti
 assert(seme>=0 && seme<4);
 if (seme == BELLO)
 {
  stat->nori++;
  ora->rimaste.ceoro[valore]= false;
 }
 // conta primiera
 assert(valore>0 && valore<11);
 if (valprim[valore] > valprim[stat->prim[seme]])
  stat->prim[seme] = valore;
 // massimo valore di primiera non in mano all'avversario
 for (i = 10;
     (i>0) &&
     ora->prese[avversario(squadra)].info[ordprim[i]][seme].edentro;
      i--);
 for (a = 10;
     (a>0) &&
     ora->prese[squadra].info[ordprim[a]][seme].edentro;
      a--);
 // massima primiera ancora fattibile  dalle due squadre
 if  (valprim[ordprim[i]] > valprim[stat->prim[seme]])
  stat->maxprim[seme] = ordprim[i];
 else stat->maxprim[seme] = stat->prim[seme];

 if  (valprim[ordprim[a]] > valprim[astat->prim[seme]])
  astat->maxprim[seme] = ordprim[a];
 else astat->maxprim[seme] = astat->prim[seme];

 // conta napula
 if ((seme == BELLO) && (valore <= TRE))
  stat->stanap++;
 // pari e dispari carte rimaste in gioco: in mano a qualcuno o a terra
 ora->rimaste.arr[valore]--;

}
//---------------------------------------------------------------------------
// aggiorna le statistiche prendendo in input un gruppo di carte (prese)
void aggiornastatgruppo(int squadra,const Gruppo *source,Stato *ora)
{
 int val,sem;
 
 for (val = ASSO; val<=RE; val++)            	// per ogni valore carta
  if (source->quanti[val] > 0)            		// salta valori non posseduti
   for (sem = 0; sem<4; sem++)              	// per ogni seme
    if (source->info[val][sem].edentro)     	// se possiede la carta
    	aggiornastatcarta(squadra,val,sem,ora);

 ora->upresa = squadra; 						// ultima squadra che ha preso
}
//---------------------------------------------------------------------------
void mettistoria(int chi,const Giocata *cg,Stato *ora)
{
 int i,j;
 // impila nuova giocata
 ora->storia.giocata[ora->storia.num] = *cg;
 ora->storia.terra[ora->storia.num] = ora->terra;
 ora->storia.rimaste[ora->storia.num] = ora->rimaste;
 // DEB forse inutile
 for (i=0; i<11; i++)
  for (j=0; j<4; j++)
   ora->storia.poggiate[ora->storia.num].arr[i][j] = ora->poggiate[i][j];
 ora->storia.num++;

 // quante ne ha giocate di quel valore il giocatore chi
 ora->poggiate[cg->poggia.valore][chi]++;
}
//---------------------------------------------------------------------------
//  mette a terra la carta giocata e fa l'eventuale presa
//  false == balla, true == prende
bool faGiocata(int chi, int quando,Giocata cg,Stato *ora)
{
 Gruppo *prese = &(ora->prese[getsquadra(chi)]);
 Gruppo *terra = &(ora->terra);

 // conta le carte rimaste in mano
 // coincide con .tot di inmano che pero' e' un dato privato al giocatore
 ora->tot[chi]--;
 // se la terra e' vuota
 if (evuoto(&(cg.prendi)))
  //Se non ha preso aggiunge la carta a terra (balla)
  {
   int somma = sommavalori(terra); //DEB non so se va fatto qui il calcolo
   metticarta(cg.poggia,terra);
   mettistoriacarta(chi,quando,somma,cg.poggia,terra);
   mettistoria(chi,&cg,ora);
   return false;
  }
  else	//Altrimenti mette la presa nelle proprie prese
  		//e le toglie da Terra
  {
   int somma = sommavalori(terra); // DEB non so se va fatto qui il calcolo

   metticarta(cg.poggia,terra);
   mettistoriacarta(chi,quando,somma,cg.poggia,terra);
   // mette tra le prese
   mettistoriagruppo(chi,quando,somma,&(cg.prendi),prese);
   aggiornastatgruppo(getsquadra(chi),&(cg.prendi),ora);
   // toglie da terra
   togligruppo(&(cg.prendi),terra);
   mettistoria(chi,&cg,ora);
   return true;
  }
}

//---------------------------------------------------------------------------
// riempie la giocata con la carta e con il gruppo di carte
void setgiocata(Carta c,const Gruppo *gc,Giocata *g)
{
 g->prendi = *gc;
 metticarta(c,&(g->prendi));  // AAA aggiunge tra le prese la carta poggiata
 g->poggia = c;
}
//---------------------------------------------------------------------------
// restituisce un puntatore alla prima posizione libera in un array di giocate
// una specie di push in uno stack
Giocata* libera(AGiocata *a)
{
  return &(a->arr[a->pos]);
}
//---------------------------------------------------------------------------
// controlla se a terra c' una carta di un certo valore
// (non tiene conto del seme)
bool cevalore(const Gruppo *terra,int valore,Carta *cartaterra)
{
 int i;
 if (terra->quanti[valore] > 0)
 {
  cartaterra->valore = valore;
  for (i=0;!(terra->info[valore][i].edentro) && i<4; i++);
  cartaterra->seme = i;
  return true;
 }
 else return false;
}
//---------------------------------------------------------------------------
// mette nell'elenco delle possibili prese carta ballata
void balla(Carta poggio, AGiocata *elencoprese)
{
 Giocata *giocata;

 giocata = libera(elencoprese);
 giocata->prendi.tot = 0;
 giocata->poggia = poggio;
 elencoprese->pos++;
}
//---------------------------------------------------------------------------
// mette nell'elenco delle possibili prese una presa singola
void prendiuna(Carta cartaterra,
			 Carta poggio, AGiocata *elencoprese)
{
 Giocata *giocata;
 Gruppo prese;

 initgruppo(&prese);
 giocata = libera(elencoprese);
 metticarta(cartaterra, &prese);
 setgiocata(poggio,&prese,giocata);
 elencoprese->pos++;
}
//---------------------------------------------------------------------------
// mette nell'elenco delle possibili prese una presa doppia
void prendidue(Carta cartaterra,Carta cartaterra2,
 			 Carta poggio, AGiocata *elencoprese)
{
 Giocata *giocata;
 Gruppo prese;

 initgruppo(&prese);
 giocata = libera(elencoprese);
 metticarta(cartaterra, &prese);
 metticarta(cartaterra2, &prese);
 setgiocata(poggio,&prese,giocata);
 elencoprese->pos++;
}
//---------------------------------------------------------------------------
// mette nell'elenco delle possibili prese una presa tripla
void prenditre(Carta cartaterra,Carta cartaterra2,Carta cartaterra3,
 			 Carta poggio, AGiocata *elencoprese)
{
 Giocata *giocata;
 Gruppo prese;

 initgruppo(&prese);
 giocata = libera(elencoprese);
 metticarta(cartaterra, &prese);
 metticarta(cartaterra2, &prese);
 metticarta(cartaterra3, &prese);
 setgiocata(poggio,&prese,giocata);
 elencoprese->pos++;
}

//---------------------------------------------------------------------------
// Calcola data una carta quali 'prese' si possono fare con le carte a terra
// ognuna  una possibile coppia (carta poggiata,carte prese)
// con la stessa carta ci possono essere piu prese
void giocatePossibili(Carta poggio,AGiocata *elencoprese,const Stato *stato)
{
	int i;

	Giocata *giocata;
    Carta cartaterra,cartaterra2,cartaterra3;
    Gruppo prese;

    elencoprese->pos = 0;  // init elenco prese
    initgruppo(&prese);
    // Presa d'asso tutte le carte a terra pi l'asso
    if (poggio.valore == 1)
    {
     giocata = libera(elencoprese);
     setgiocata(poggio,&(stato->terra),giocata);
     elencoprese->pos++;
	}
    //Valori in 2..4 carta singola
    else if ((poggio.valore >= 2) && (poggio.valore <= 4))
    {
     if (cevalore(&(stato->terra),poggio.valore,&cartaterra) )
		 prendiuna(cartaterra,poggio,elencoprese);
    }
    // Presa carta singola > 4
    else if (cevalore(&(stato->terra),poggio.valore,&cartaterra) )
    	    prendiuna(cartaterra,poggio,elencoprese);
    // Presa multipla
    else if (stato->terra.tot > 1)
    {
     //Per ogni tipo di presa della carta c
	 for (i = 0; i < numpos[poggio.valore]; i++)
     {
      assert(numimp[poggio.valore][i] != 1);
	  switch (numimp[poggio.valore][i])
      {
	  case 2:		// Raccoglie due carte
		if (cevalore((&stato->terra),comb[poggio.valore][i][0],&cartaterra) &&
			cevalore((&stato->terra),comb[poggio.valore][i][1],&cartaterra2))

        prendidue(cartaterra,cartaterra2,poggio,elencoprese);
        break;
   	  case 3:			//Raccoglie tre carte
		if (cevalore((&stato->terra),comb[poggio.valore][i][0],&cartaterra) &&
			cevalore((&stato->terra),comb[poggio.valore][i][1],&cartaterra2) &&
			cevalore((&stato->terra),comb[poggio.valore][i][2],&cartaterra3))

    	prenditre(cartaterra,cartaterra2,cartaterra3,poggio,elencoprese);
        break;
	  default :      // DEB non deve arrivare qui
    	assert(true);
	}
   }
  }
// balla la carta
if (elencoprese->pos == 0)
	balla(poggio,elencoprese);

}
//---------------------------------------------------------------------------
// cerca la prima carta (alto-basso sinistra-destra) nella bitmap gruppo carte
// funziona solo se il gruppo di carte non e vuoto
Carta primacarta(const Gruppo *g)
{
 int i;
 Carta c;

 for (i=1; i<11 && (g->quanti[i] == 0);i++);
 assert(i<11);
 c.valore = i;
 for (i=0; i<4 && (!g->info[c.valore][i].edentro);i++);
 assert(i<4);
 c.seme = i;

 return c;
}

//---------------------------------------------------------------------------
// cerca la carta dopo la carta c (vedi primacarta())
bool proxcarta(const Gruppo *g,Carta *c)
{
 int s,v;
 // cerca carta con stesso valore e altro seme
 for (s=c->seme+1;
 		s<4 && (!g->info[c->valore][s].edentro);
        s++);
 if (s>3)
 {
  // cerca carta con valore superiore
  for (v=c->valore+1; v<11 && (g->quanti[v] == 0);v++);
  if (v>10) return false;
  else  for (s=0; s<4 && (!g->info[v][s].edentro);s++);
  c->valore = v;
  c->seme = s;
  return true;
 }
 else
 {
  // stesso valore seme diverso
  c->seme = s;
  return true;
 }
}
//---------------------------------------------------------------------------
// Metti un insieme di giocate in fondo ad un altro
// una specie di push in uno stack
void mettigiocate(AGiocata *sorg, AGiocata *dest)
{
 int s,d;
 for (s = 0,d=dest->pos; s<sorg->pos; d++,s++)
  dest->arr[d] = sorg->arr[s];
 dest->pos += sorg->pos;
}

//---------------------------------------------------------------------------
// distribuisce le carte
void distribuisci(AGruppo *giocatore)
{
 int i, j = 40, indice [40], valore, seme, achi = 0;
 Carta c;
 unsigned tdeb; // DEB
 struct  time t;

 // inizializza randomizzazione (randomize non funziona se usato a
 // distanze temporali minori di un secondo)
 gettime(&t);
 //printf("\nThe current time is: %2d:%02d:%02d.%02d\n", // DEB
 //t.ti_hour, t.ti_min, t.ti_sec, t.ti_hund);            // DEB

 //srand(tdeb = t.ti_hour*1000000+ t.ti_min*10000+ t.ti_sec*100+ t.ti_hund);
 //printf("Somma %d\n",tdeb);                            // DEB

 //srand(1); //DEB muta inizio random dando sempre gli stessi valori
 for (i = 0; i < 40; i++) indice[i] = i;
 while (j > 0)
 {
  // DEB i = random(j);
  i = rand() % j;
  valore = (indice[i]%10) + 1;
  seme = indice[i]/10;
  j--;
  indice[i] = indice[j];
  setcarta(valore,seme,&c);
  metticarta(c, &(giocatore->arr[achi]));
  achi = ++achi % 4;
 }
}
 //---------------------------------------------------------------------------
 // int della stato ad partita a 21
 void iniziapartita(Stato *s)
 {
  s->tuttipunti[0] = 0;
  s->tuttipunti[1] = 0;
 }
//---------------------------------------------------------------------------
// inizializza lo stato del gioco a inizio mano
void initstato(Stato *s)
{
 int i,j,k;

 // numero di carte in mano ai giocari all'inizio
 // coincide con s->inmano->tot che pero' e' un dato privato
 s->tot[0] = 10;
 s->tot[1] = 10;
 s->tot[2] = 10;
 s->tot[3] = 10;

 // inmano e contenuto in un a struttura esterna
 initgruppo(&(s->terra));
 initgruppo(&(s->prese[0]));
 initgruppo(&(s->prese[1]));

 // inutile azzerarlo in teoria (per sicurezza)
  s->mazziere = 0;

 // da azzerare ad ogni mano
 s->spunti.punti[0] = 0;
 s->spunti.punti[1] = 0;
 s->spunti.scope[0] = 0;
 s->spunti.scope[1] = 0;
 s->stat[0].nori = 0;
 s->stat[1].nori = 0;
 s->stat[0].prim[0] = 0;
 s->stat[0].prim[1] = 0;
 s->stat[0].prim[2] = 0;
 s->stat[0].prim[3] = 0;
 s->stat[1].prim[0] = 0;
 s->stat[1].prim[1] = 0;
 s->stat[1].prim[2] = 0;
 s->stat[1].prim[3] = 0;
 s->stat[0].maxprim[0] = 7;
 s->stat[0].maxprim[1] = 7;
 s->stat[0].maxprim[2] = 7;
 s->stat[0].maxprim[3] = 7;
 s->stat[1].maxprim[0] = 7;
 s->stat[1].maxprim[1] = 7;
 s->stat[1].maxprim[2] = 7;
 s->stat[1].maxprim[3] = 7;
 s->stat[0].stanap = 0;
 s->stat[1].stanap = 0;

 // init punti;
 s->spunti.primiera = -1;
 s->spunti.carte = -1;
 s->spunti.ori = -1;
 s->spunti.settebello = -1;

 s->spunti.napula = -1;
 s->spunti.quantinapula = 0;

 s->spunti.scope[NS] = 0;
 s->spunti.scope[EO] = 0;

 s->spunti.maxprim[NS] = 0;
 s->spunti.maxprim[EO] = 0;
 s->spunti.prim[NS] = 0;
 s->spunti.prim[EO] = 0;

 s->spunti.punti[NS] = 0;
 s->spunti.punti[EO] = 0;

 // pari e dispari, rimaste a terra e in mano
 for (i=ASSO; i<=RE; i++)
 {
   s->rimaste.arr[i] = 4;
   s->rimaste.ceoro[i] = true;
 }
   //DEB non aggiornata probabilmente inutile
 for (j=0; j<4; j++)
  for (i=ASSO; i<=RE; i++)
   s->poggiate[i][j] = 0;

 // previsioni
 for (j=0; j<4; j++)
  for (i=0; i<4; i++)
   for (k=0; k<10; k++)
   {
    s->prev[j][i].hacarta[k];
    s->prev[j][i].hoinfo[k];
    s->prev[j][i].haoro[k];
   }
 //
 s->storia.num = 0;
}
//---------------------------------------------------------------------------
// conta numero di carte pari in un gruppo di carte
int contapari(Stato *ora)
{
 int val,c;

 for(val = DUE, c=0; val<=RE; val++)
  if (ora->rimaste.arr[val]%2 == 0) c++;

 return c;
}
//---------------------------------------------------------------------------
// conta il numero di carte dispari in un gruppo di carte
int contadispari(Stato *ora)
{
 int val,c;

 for(val = DUE, c=0; val<=RE; val++)
 if (ora->rimaste.arr[val]%2 == 1) c++;

 return c;
}
//---------------------------------------------------------------------------
// conta il valore totale della primiera
int contaprim(int *prim)
{
 return valprim[prim[0]] +
 		valprim[prim[1]] +
 		valprim[prim[2]] +
 		valprim[prim[3]];
}

//---------------------------------------------------------------------------
// conta i punti fatti sino a quel momento
// puo contarli anche al centro della partita
// DEB quando una primiera e gia sicura??? per quale valore??
// restituisce una struttura contenente il punteggio diviso per tipo
// i valori di mazzo sono a -1 quando il punto e' stato pareggiato
Punti contapunti(Stato *stato)
{
   int i,n,s;

   //init
   stato->spunti.punti[NS]=0;
   stato->spunti.punti[EO]=0;
   //  napula
   s = -1;
   n = 0;
   if (stato->prese[NS].info[ASSO][BELLO].edentro)  s = NS;
   else if (stato->prese[EO].info[ASSO][BELLO].edentro)s = EO;
   if (s>=NS) // qualcuno ha l'asso bello
    for (i=1; i<=10; i++)
    {
     if (stato->prese[s].info[i][0].edentro) n++;
     else break;
   }
   if (n >= 3)
   {
   	stato->spunti.punti[s] += n;
    stato->spunti.napula = s;
    stato->spunti.quantinapula = n;
   }

   // ori
   if (stato->stat[NS].nori > 5)
   {
   	stato->spunti.punti[NS]++;
    stato->spunti.ori = NS;
   }
   else if (stato->stat[EO].nori > 5)
   {
   	stato->spunti.punti[EO]++;
    stato->spunti.ori = EO;
   }

   // sette bello
   if (stato->prese[NS].info[SETTE][BELLO].edentro)
   {
   	stato->spunti.punti[NS]++;
    stato->spunti.settebello = NS;
   }
   else if (stato->prese[EO].info[SETTE][BELLO].edentro)
   {
   	stato->spunti.punti[EO]++;
    stato->spunti.settebello = EO;
   }

   //carte
   if (stato->prese[NS].tot > 20)
   {
   	stato->spunti.punti[NS]++;
    stato->spunti.carte = NS;
   }
   else if (stato->prese[EO].tot > 20)
   {
   	stato->spunti.punti[EO]++;
    stato->spunti.carte = EO;
   }

   //primiera
   stato->spunti.prim[NS] =  contaprim(stato->stat[NS].prim);
   stato->spunti.prim[EO] =  contaprim(stato->stat[EO].prim);
   stato->spunti.maxprim[NS] = contaprim(stato->stat[NS].maxprim);
   stato->spunti.maxprim[EO] = contaprim(stato->stat[EO].maxprim);
   stato->spunti.maxmaxprim = stato->spunti.maxprim[NS];
   // maggiore tra i valori massimi primiera conseguibili
   if (stato->spunti.maxprim[EO] > stato->spunti.maxprim[NS])
    stato->spunti.maxmaxprim = stato->spunti.maxprim[EO];
   // chi fa primiera
   if (stato->spunti.prim[NS] > stato->spunti.maxprim[EO])
   {
    stato->spunti.punti[NS]++;
    stato->spunti.primiera = NS;
   }
   else if (stato->spunti.prim[EO] > stato->spunti.maxprim[NS])
   {
    stato->spunti.punti[EO]++;
    stato->spunti.primiera = EO;
   }

   //scope
   stato->spunti.punti[NS] += stato->spunti.scope[NS];
   stato->spunti.punti[EO] += stato->spunti.scope[EO];

   //metti nel conteggio complessivo
   stato->tuttipunti[NS] += stato->spunti.punti[NS];
   stato->tuttipunti[EO] += stato->spunti.punti[EO];

   return stato->spunti;
 }
 //---------------------------------------------------------------------------
// restituisce vero se la squadra puo fare ancora fare il punto di primiera
// falso se qualcuno lo ha gia conseguito o e stato pareggiato
// lo posso ancora conseguire quando il valore effettivo del mio avversario
// non ha superato il mio valore massimo
// DEB problemi con l'uguaglianza
bool pprimiera(int squadra,Stato *stato)
{
  return
   stato->spunti.prim[avversario(squadra)] <= stato->spunti.maxprim[squadra];
}
//---------------------------------------------------------------------------
// restituisce vero se la squadra puo fare ancora fare il punto di napula
// falso se qualcuno lo ha gia conseguito o nessuno lo puo conseguire
bool pnapula(Stato *stato)
{
 return (stato->stat[NS].stanap * stato->stat[EO].stanap == 0);
}
//---------------------------------------------------------------------------
// restituisce vero se la squadra ha gia fatto il punto di napula
bool fnapula(int squadra,Stato *stato)
{
 // DEB dovrebbe restituire l'ultima carta di napula valida
 // DEB es: ASSO, DUE TRE QUATTRO (non il 5) di ori --> restituisce 4
 return (stato->stat[squadra].stanap == 3);
}
//---------------------------------------------------------------------------
// restituisce vero se la squadra puo ancora fare il punto di carte
// falso se qualcuno lo ha gia conseguito
bool pcarte(Stato *stato)
{
 if ((stato->prese[NS].tot > 20) || (stato->prese[EO].tot > 20))
 	return false;
 else return true;
}
//---------------------------------------------------------------------------
// restituisce vero se la squadra puo fare ancora fare il punto di ori
// falso se qualcuno lo ha gia conseguito o e stato pareggiato
bool pori(Stato *stato)
{
 if ((stato->stat[NS].nori > 5) || (stato->stat[EO].nori > 5))
 	return false;
 else if (stato->stat[NS].nori == 5)
 	return false;
 else
 	return true;
}

 //---------------------------------------------------------------------------
 // Muta lo stato di gioco in funzione di una giocata fatta
 void cambiastato(int chi,int quando,Giocata mossa,Gruppo *inmano,Stato *ora)
 {
    //Aggiorna le carte a terra e le prese (controlla scopa)
    if  (faGiocata(chi,quando,mossa,ora) &&
    	(mossa.poggia.valore != ASSO) &&
        (ora->terra.tot == 0) &&
        (quando < 39)) //non e' l'ultima presa
    			ora->spunti.scope[getsquadra(chi)]++;
    //Toglie la carta posata dalle carte in mano
    toglicarta(mossa.poggia,inmano);
    contapunti(ora);
 }

//---------------------------------------------------------------------------
//cambia turno e da le carte in mano al giocatore
void cambiaturno(int nmosse,int *chi,int *squadra,AGruppo *tutte,Stato *ora)
{
    *chi = (*chi+1)%4;
    *squadra = nmosse%2;
    ora->inmano = &(tutte->arr[*chi]);
}


//---------------------------------------------------------------------------
// vero se la squdra e di mazzo
bool sonodimazzo(int squadra,Stato *stato)
{
  return (stato->mazziere%2 == squadra);
}

//---------------------------------------------------------------------------
// vera se in gioco, (non tra le prese) cioe  (in mano o a terra)
bool ingioco(int val,int seme,Stato *ora)
{
 return !(ora->prese[NS].info[val][seme].edentro ||
 		  ora->prese[EO].info[val][seme].edentro);
}


//---------------------------------------------------------------------------
// mette nel array s tutte le somme fattibili tra le carte contenute in g
void sommepossibili(Arr11 *s, Gruppo *g)
{
 int i,j,k,c,tot,arr[10];

 for (c=0,i=DUE; i<= RE; i++)
 {
  s->arr[i] = false;
  if (g->quanti[i]>0)
  {
   s->arr[i] = true;
   arr[c] = i;
   c++;
  }
 }

 for (i = 0; i<c; i++)
  for (j = i + 1; j < c; j++)
  {
   tot = arr[i] + arr[j];
   if (tot <= RE)
    s->arr[ tot ] = true;
  }

 for (i = 0; i<c; i++)
  for (j = i + 1; j < c; j++)
   for (k = j + 1; k < c; k++)
    {
     tot = arr[i] + arr[j] + arr[k];
     if (tot <= RE)
      s->arr[ tot ] = true;
    }
}

//---------------------------------------------------------------------------
// elenca tutte le possibili giocate fattibili con le carte inmano
// mettendole poi in tutteprese
void ognigiocata(AGiocata *tutteprese,const Stato *stato)
{
 Carta poggio;
 AGiocata questapresa;
 int ncarta;

 tutteprese->pos = 0; // init
 // DEB fare diventare procedura
 //mette in tutteprese tutte le prese possibili con le carte inmano
 poggio = primacarta(stato->inmano);
 giocatePossibili( poggio, &questapresa, stato);
 mettigiocate(&questapresa,tutteprese);
 for (ncarta = 1; ncarta <= stato->inmano->tot; ncarta++)
 {
  if (proxcarta(stato->inmano,&poggio))
  {
   giocatePossibili(poggio, &questapresa, stato);
   mettigiocate(&questapresa,tutteprese);
  }
 }
}


//---------------------------------------------------------------------------
// muove il mazzo e  restituisce  a chi arrivato in funzione del numero di mani
// giocate
int daimazzo(int chidimazzo,Stato *stato)
{
  return (stato->mazziere = chidimazzo);
}
//---------------------------------------------------------------------------
// da le carte rimaste a terra alla squadra che ha preso per ultima
void prendiultime(Stato *ora)
{
 Giocata cg;
 int squadra = ora->upresa%4;
 Gruppo *prese = &(ora->prese[squadra]);
 Gruppo *terra = &(ora->terra);

 cg.prendi = ora->terra;
 if (!evuoto(&(cg.prendi)))
 {
 	aggiornastatgruppo(squadra,&(cg.prendi),ora);
 	mettigruppo(&(cg.prendi),prese);
 	togligruppo(&(cg.prendi),terra);
 }
}
//---------------------------------------------------------------------------
// stabilisce chi ha vinto la partita
// la partita finisce quando una squadra a raggiunto fine e ha piu punti
// dell'avversario
// restituisce squadra vincente in 'chihavinto'
// vero se qualcuno ha vinto falso altrimenti
bool finegioco(int fine,int *chihavinto,Stato *s)
{
 if ((s->tuttipunti[NS] > s->tuttipunti[EO]) && (s->tuttipunti[NS] >= fine))
 {
  *chihavinto = NS;
  return true;
 }
 else
 if ((s->tuttipunti[EO] > s->tuttipunti[NS]) && (s->tuttipunti[EO] >= fine))
 {
  *chihavinto = EO;
  return true;
 }
 return false;
}

