//---------------------------------------------------------------------------
// TuScopa v0.047  (Stegh Traibaj & Tludet Dejouga Eldoeu j Pirlunsteset)
// Copyleft 1998 ACME Inc (ex Tugomira Soft)
//---------------------------------------------------------------------------
// header del progetto tu scopa: tuscopa.h
//---------------------------------------------------------------------------
#define getsquadra(chi) (chi & 1)
#define avversario(chi) ((chi+1)%2)

#define compagno(chi) ((chi+2)%4)
#define prossimo(chi)  ((chi+1)%4)
#define io(chi) chi
#define precedente(chi) ((chi-1)%4)

enum {ASSO=1,DUE,TRE,QUATTRO,CINQUE,SEI,SETTE,FANTE,CAVALLO,RE};
enum {BELLO,CUORI,FIORI,PICCHE};
enum {NS,EO};
//---------------------------------------------------------------------------
typedef struct
{
 unsigned edentro 	: 1;  	// vero se la carta e' contenuta
 unsigned cera		: 1;	// vera se la carta e stata dentro
 unsigned chi 		: 2;  	// chi l'ha messa (secondo bit quale squadra)
 unsigned quandoin 	: 6;  	// a quale mossa e entrata

 unsigned somma		: 6;    // somma valori a terra
 unsigned status   	: 8; 	// DEB non usato
} Info;

// struttura restituita da conta punti
typedef struct
{
 int settebello,carte,primiera,ori,napula; // quale squadra ha fatto il punto
 int scope[2], 		// quante scope per squadra, punti totali
 	 punti[2];   	// punti di questa mano
 int quantinapula;  // quanti punti di napula sono stati fatti
 int maxprim[2],    // totali primiera massimi e effettivi
     prim[2],
     maxmaxprim;    // maggiore tra i maxprim[]
} Punti;

typedef struct
{
 bool hacarta[11];  // ci si aspetta abbia ancora quella carta?
 bool hoinfo[11];	// ho informazioni su quella carta?
 bool haoro[11];    // ci si aspetta abbia anche la carta di ori?
} Previsione;

typedef struct
 {
  int valore,seme;
 } Carta;

typedef struct
 {
  int
   tot,                 // numero di carte contenute
   quanti[11];          // numero di carte per valore
  Info
   info[11][4];      	// bitmap carte
 } Gruppo;

typedef struct
{
 int nori;           	// numero di ori per squadra
 int prim[4];        	// massimo valore primiera per squadra e seme
 						// DEB non ancora aggiornato
 int maxprim[4];		// massima valore di primiera conseguibile
 						// con le carte non gia' prese
       					// carte:stato.prese[].tot
 						// settebello: stato.prese[].edentro[SETTE][BELLO}
 int stanap;            // numero di ori nell'insieme (Asso, due,  tre)
} Stat;

typedef struct
{
 Carta poggia;    		// carta che si vuole posare
 Gruppo prendi;         // carte che si vogliono prendere
} Giocata;

typedef struct
{
 int arr[11][4];
} Arr114;

typedef struct
{
 bool arr[11];
} Arr11;

typedef struct
{
 int arr[11];
 bool ceoro[11];
} Rimaste;

typedef struct
{
  Giocata giocata[40];  // giocate fatte sino a questo momento
  Gruppo  terra[40];	// carte a terra in quel momento
  Arr114  poggiate[40];	// quante in gioco in quel momento
  Rimaste rimaste[40];
  int num;
} Storia;

typedef struct
{
 int
  tuttipunti[2],		// punteggio della squadra  (totale)
  upresa,				// chi ha compiuto l'ultima presa
  mazziere,				// chi e' il mazziere
  tot[4],				// rimaste in mano al giocatore i
  						// DEB  forse inutile
  poggiate[11][4];		// quante per valore sono state giocate da ognuno
 Punti
  spunti;				// stato quantita e tipo dei punti fatti
  						// DEB usando questo si potrebbero eliminare
                        // DEB scope[], punti[]
 Rimaste
  rimaste;				// numero di carte a terra o in mano (per ogni valore)
 Stat
  stat[2];				// statistiche sullo stato di gioco (punti potenziali)
 Gruppo
  terra, 				// lista delle carte a terra
  *inmano,				// carte in mano al giocatore
  prese[2];				// carte prese da una squadra
 Storia
  storia;				// giocate sino a questo momento
 Previsione
  prev[4][4];			// carte previste degli avversari
  						// [chi prevede][carte di chi]
} Stato;


typedef struct
{
 int valore;   			// risultato del motore AI (bont della mossa)
 Giocata mossa;			// giocata da fare
} Risultato;

typedef struct         	// array di giocate, una specie di stack
{                       //(c'e solo il push)
 int pos;
 Giocata arr[50];     	// DEB grandezza sovrastimata (SOL: alloc. dinamica)
} AGiocata;

 typedef struct
{
 Gruppo arr[4];       	// Array di gruppi di carte, contiene tutte le carte
} AGruppo;
//---------------------------------------------------------------------------
// Variabili Globali
extern Stato oras;             // stato di gioco
extern AGruppo tuttelecarte;   // stato (carte ancora in mano)
extern Risultato ris;          // carta scelta ed eventuale presa e valore
//---------------------------------------------------------------------------
// procedure visibili all'esterno di tuscopa
extern int contaprim(int *prim);
extern int contadispari(Stato *ora);
extern int contapari(Stato *ora);
extern bool pprimiera(int squadra,Stato *stato);
extern bool pnapula(Stato *stato);
extern bool pcarte(Stato *stato);
extern bool pori(Stato *stato);
extern
 void cambiastato(int chi,int quando,Giocata mossa,Gruppo *inmano,Stato *ora);
extern
 void cambiaturno(int nmosse,int *chi,int *squadra,AGruppo *tutte,Stato *ora);
extern void initstato(Stato *s);
extern void distribuisci(AGruppo *giocatore);
extern int  daimazzo(int chidimazzo,Stato *stato);
extern void prendiultime(Stato *ora);
extern Punti contapunti(Stato *stato);
extern bool finegioco(int fine,int *chihavinto,Stato *s);
extern void iniziapartita(Stato *s);
