//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#pragma hdrstop

#include <assert.h>
#include <math.h>

#include "tuscopa.h"
#include "stocasti.h"
#include "Maindeb.h"
#include "motore01.h"
//---------------------------------------------------------------------------
extern void sommepossibili(Arr11 *s, Gruppo *g);
extern int sommavalori(const Gruppo *gruppo);
extern bool sonodimazzo(int squadra,Stato *stato);
extern bool ingioco(int val,int seme,Stato *ora);
extern void ognigiocata(AGiocata *tutteprese,const Stato *stato);
extern bool fnapula(int squadra,Stato *stato);

// DEB dovrebbe essere solo in tuscopa ed essere esterna (come si fa?)
// valore primiera per ogni carta
const int valprim[11] =
{0,16,12,13,14,15,18,21,10,10,10};

//---------------------------------------------------------------------------
// vera se 'chi' ha messo a terra una carta di tipo valore su terra vuota
bool ballarischio(unsigned chi,int v,const Gruppo *terra)
{
 int s;

 for (s=0; s<4; s++)
 {
  if ((terra->info[v][s].cera) &&
  	  (terra->info[v][s].chi == chi) &&
      (terra->info[v][s].somma <= 10))
  return true;
 }
 return false;
}
//---------------------------------------------------------------------------
// bonta statica della giocata (ver 0.01)
int euristica01(int rimaste,int chi,Giocata mossa,Stato *nuovo,Stato *vecchio)
{
 int out = 0,tot,ringiro,squadra;
 Arr11 somme;

 squadra = getsquadra(chi);
 // 100  rappresenta un punto fatto gli altri valori vanno messi di conseguenza

 // punti ***************************
 // carte
 if (pcarte(vecchio))
 	out += nuovo->prese[squadra].tot * 5;
 // punti gia fatti (ori ad esempio)
 out += nuovo->spunti.punti[squadra]*100;
 // scope (gia contato in punti, punteggio maggiore perche sicura)
 out += nuovo->spunti.scope[squadra]*20;
 // primiera
 if (pprimiera(squadra,vecchio))
  if (valprim[mossa.poggia.valore] >= valprim[CINQUE]) // piu importanti carte >= 5
 	out += contaprim(nuovo->stat[squadra].prim);
  //else                                 // DEB dare importanza solo nei giusti
    //out += contaprim(nuovo->stat[squadra])/2;  // DEB momenti alle <5
 // ori
 if (pori(vecchio))
 	out += nuovo->stat[squadra].nori*20;
 // napula
 tot =  nuovo->stat[squadra].stanap;
 //DEB i controllo puo fare ancora napula vengono fatti dopo che la
 //DEB giocata fantasma e' stata compiuta quindi sbaglia
 //ES lui ha l'asso, io posso prendere il tre bello ma quando arrivo
 //ES qui lui si comporta come se l'avessi effettivamente gia fatto
 //ES e salta questo if
 //SOLUZIONE passsare lo stato prima e dopo la giocata fantasma e confrontarli
 if  (pnapula(vecchio))     		// se qualcuno puo ancora fare napula nello
 									// stato reale
  if (tot >= 3) out += 100*tot;   	// fatto il punto
  else out += 70*tot;             	// puo fare il punto

 // difesa ***************************
 // non lasciare a terra una somma minore di 10 (rischio scopa)
 // in funzione del numero di carte rimaste
 tot = sommavalori(&(nuovo->terra));
 if (tot<=RE)
 {
  ringiro =                                  // #carte rimaste in giro
 	nuovo->rimaste.arr[tot] -                   // a terra o in mano a qualcuno
    nuovo->inmano->quanti[tot] -            // meno quelle che io ho in mano
    nuovo->terra.quanti[tot];               // meno quelle che sono gia a terra
  if (nuovo->prev[chi][compagno(chi)].hoinfo[mossa.poggia.valore] &&
     nuovo->prev[chi][compagno(chi)].hacarta[mossa.poggia.valore] &&
     ringiro>0)
    ringiro--; //meno la carta che penso abbia il mio compagno
 }
 assert(ringiro>=0); 						//DEB
 if (tot <= RE && tot > 0 &&                // possibilita di scopa se ci sono
     ringiro>0)                             // ancora carte di quel valore
 // probabilita (* 100) che il prossimo abbia almeno una carta con valore tot
 // ovvero (1 - probabilita che non ne abbia manco una)
 // M: numero di carte ancora in mano agli avversari; K: numero di carte in mano
 // di quel valore in mano agli avversari; n: numero di carte in mano al
 // giocatore
  	out -= ceil(100. *
    	(1 -
  		iper(rimaste - nuovo->inmano->tot,	// M = popolazione
  			ringiro,						// K = num. difettose
    		nuovo->inmano->tot,				// n = campione
    		0)));                           // k = difet. nel campione

 // pari i mazzari, dispari i contromazzari
 // DEB differenziare per tipo di carta
 // DEB i.e. jack dispari meno importante del sette dispari
 if (sonodimazzo(squadra,nuovo))
  out += contapari(nuovo)*10 - contadispari(nuovo)*10;
 else
  out += contadispari(nuovo)*10 - contapari(nuovo)*10;

 if (mossa.prendi.tot == 0)       				   // se ballo
 {
  // non ballare inutilmente carte importanti
  if ((mossa.poggia.seme == BELLO) && pori(nuovo)) // se carta bella
    out -= 15;
  if ((mossa.poggia.valore <= TRE) &&    		   // se permette la napula
  		pnapula(vecchio) &&                		   // la napula e fattibile

        ingioco(mossa.poggia.valore,BELLO,nuovo)&& // la carta e ancora in gioco
        (!nuovo->inmano->info[mossa.poggia.valore][BELLO].edentro)) //io inmano
     out -= 20;
  if (fnapula(squadra,nuovo) &&          // anche  4,5..  se la napula gia fatta
        ingioco(mossa.poggia.valore,BELLO,nuovo)&& // la carta e ancora in gioco
        (!nuovo->inmano->info[mossa.poggia.valore][BELLO].edentro)) //io in mano
     out -= 100;
  if (valprim[mossa.poggia.valore] >  			   // se aiuta la primiera
      valprim[nuovo->stat[squadra].prim[mossa.poggia.seme]])
   out -= valprim[mossa.poggia.valore];

   									// butto carte di cui ho quella di denari
  if (nuovo->inmano->info[mossa.poggia.valore][BELLO].edentro)
   out += 30;
   // rispondere al compagno se lui considerava la carta sicura (balla a rischio)
  //if (ballarischio(compagno(chi),mossa.poggia.valore,&(nuovo->terra)))
  //  out +=40; //DEB tuning di questo valore
  // non gettare carte buttate a rischio dal prossimo ( ne ha un'altra)

  //if (ballarischio(prossimo(chi),mossa.poggia.valore,&(nuovo->terra)))
  //  out -= 30;
 }

 // non giocare gli assi facilmente
 if (mossa.poggia.valore == ASSO)
  	out -= 250; 					// "meglio enculass de jouga n'ass"
 if (mossa.prendi.tot > 0)          // se prendo
 {
  if (pnapula(nuovo) && !fnapula(squadra,nuovo) && // napula fattibile & non fatta
  	  (mossa.poggia.valore <= TRE)) // prendi carte minori di tre
      out += 60;

 }
 return out;
}
//---------------------------------------------------------------------------
// Sceglie la giocata ad euristica maggiore
// prof: profondita' attuale DEB per ora fa un solo passo
// rimaste: numero totale di carte in mano ai giocatori
// chi: chi gioca in questo momento
// squadra: a quale squadra appartiene chi
// Stato: stato di gioco
Risultato scopaduro01(int prof,int rimaste,int chi, int squadra ,Stato stato)
{
 Risultato ris_succ;

 Stato nuovostato;
 Gruppo inmano;
 AGiocata tutteprese;
 int i,ibest,valore;

 // tutte le possibili giocate
 ognigiocata(&tutteprese,&stato);

 // sceglie la presa con euristica migliore
 ris_succ.valore = -1000;
 //printf(" car val    Primi Ori carte scope pun pa di o n c\n");  //DEB
 for(i = 0; i<tutteprese.pos; i++)
 {
  // crea lo stato futuro in funzione della carta giocata
  nuovostato = stato;
  inmano = *stato.inmano ;
  nuovostato.inmano = &inmano;
  // va al prossimo stato 
  cambiastato(chi, 40-rimaste,tutteprese.arr[i],&inmano,&nuovostato);
  contapunti(&nuovostato);
  // se ho trovato una mossa migliore
  if ((valore = euristica01(rimaste,chi,tutteprese.arr[i],&nuovostato,&stato)) >
  				ris_succ.valore)
  {
    ibest = i;                 // memorizza mossa migliore
    ris_succ.valore = valore;
  }
  //visueuristica(valore,squadra,tutteprese.arr[i],nuovostato); //DEB
 }

 ris_succ.mossa = tutteprese.arr[ibest];
 return ris_succ;
}

