//---------------------------------------------------------------------------
#include <vcl\condefs.h>
#pragma hdrstop

#include <assert.h>
#include <math.h>

#include "tuscopa.h"
#include "stocasti.h"
#include "Maindeb.h"
#include "motore06.h"
//---------------------------------------------------------------------------
extern void sommepossibili(Arr11 *s, Gruppo *g);
extern int sommavalori(const Gruppo *gruppo);
extern bool sonodimazzo(int squadra,Stato *stato);
extern bool ingioco(int val,int seme,Stato *ora);
extern void ognigiocata(AGiocata *tutteprese,const Stato *stato);
extern bool fnapula(int squadra,Stato *stato);

// DEB dovrebbe essere solo in tuscopa ed essere esterna (come si fa?)
// valore primiera per ogni carta
const int valprim[11] =
{0,16,12,13,14,15,18,21,10,10,10};
//---------------------------------------------------------------------------
// chiprevede ha informazioni sulla carta val del giocatore dichi?
bool so(int chiprevede, int dichi, int val, Stato *s)
{
 return s->prev[chiprevede][dichi].hoinfo[val];
}
//---------------------------------------------------------------------------
// chiprevede ha informazioni sulla carta val del giocatore dichi?
bool ha(int chiprevede, int dichi, int val, Stato *s)
{
 return s->prev[chiprevede][dichi].hacarta[val];
}
//---------------------------------------------------------------------------
// chiprevede ha informazioni sulla carta val del giocatore dichi e sa che
// la ha in mano?
bool soeha(int chiprevede, int dichi, int val, Stato *s)
{
 return s->prev[chiprevede][dichi].hoinfo[val] &&
 		s->prev[chiprevede][dichi].hacarta[val];
}
//---------------------------------------------------------------------------
// chiprevede ha informazioni sulla carta val del giocatore dichi e sa che
// la ha in mano?
bool soenonha(int chiprevede, int dichi, int val, Stato *s)
{
 return s->prev[chiprevede][dichi].hoinfo[val] &&
 		!s->prev[chiprevede][dichi].hacarta[val];
}
//---------------------------------------------------------------------------
// prevede le carte degli avversari riempiendo la struttura previsione
void previsioni06(int chi, Stato *ora)
{
 int ngio,valore,tot,totvecchio,tocca;
 Gruppo terra,terravecchia;
 Giocata giocata;
 Rimaste rimaste;
 // DEB a)se lascia scopa non aveva la carta in questione
 // DEB b)se prende non di ori come prima carta vuol dire che non l'ha (ori)


 // per ogni giocata gia fatta
 for(ngio=0; ngio< ora->storia.num; ngio++)
 {
  tocca = (ngio+1+ora->mazziere)%4;
  // non fa previsioni su se stesso
  if (tocca == chi) continue;
  // lo stato e' quello dopo aver fatto la giocata (ATTENZIONE)
  terra = ora->storia.terra[ngio];
  if (ngio>0)
   terravecchia = ora->storia.terra[ngio-1];
  giocata = ora->storia.giocata[ngio];
  rimaste = ora->storia.rimaste[ngio];
  valore = giocata.poggia.valore;

  tot = sommavalori(&terra);
  totvecchio = sommavalori(&terravecchia);

  // non fa scopa di tot quindi non ha tot
  if (ngio>0)
   if (totvecchio <= 10 && totvecchio > 0 && (terra.tot >0 || valore == ASSO))
   {
    ora->prev[chi][tocca].hoinfo[totvecchio] = true;
    ora->prev[chi][tocca].hacarta[totvecchio] = false;
   }

  // quando gioca la carta di cui avevo info, non ho piu' info
  // se info == 'ha' non l'ha piu', se info == 'nonha' mi aveva imbrogliato
  if (so(chi,tocca,valore,ora))
  {
   ora->prev[chi][tocca].hoinfo[valore] = false;
   ora->prev[chi][tocca].hacarta[valore] = false;
  }

  if  (valore != ASSO)
  {
   if (ora->rimaste.arr[valore] -
       ora->terra.quanti[valore] > 0) // ancora inmano
   {
    // chi balla un carta non sicura a rischio ne ha due o sa che il prossimo
    // non ha quella carta
    // DEB se ne ha giocate gia 2 forse non ha la terza
    // giocatore lascia terra a rischio (0<tot<=10) quindi ha tot in mano
    if (tot <= RE && tot >0)
    {
     ora->prev[chi][tocca].hoinfo[valore] = true;
     ora->prev[chi][tocca].hacarta[valore] = true;
    }

    // prende con carta non d'oro quindi non l'ha
    if (giocata.prendi.tot > 0 && rimaste.ceoro[valore])
    {
     ora->prev[chi][tocca].hoinfo[valore] = true;
     ora->prev[chi][tocca].haoro[valore] = false;
    }

    // DEB se carte di tipo sono finite o le ho io il prossimo non puo averle
   }
   // sono sicuro: non ce ne sono piu'
   else
   {
    ora->prev[chi][(ngio+ora->mazziere)%4].hoinfo[valore] = true;
    ora->prev[chi][(ngio+ora->mazziere)%4].hacarta[valore] = false;
   }
  }
 }
}
//---------------------------------------------------------------------------
// 1 se pari 0 se dispari
int pari(int val,Stato *s)
{
 return (s->rimaste.arr[val]+1)%2;
}
//---------------------------------------------------------------------------
// 1 se dispari (odd) 0 se pari
int odd(int val,Stato *s)
{
 return s->rimaste.arr[val]%2;
}
//---------------------------------------------------------------------------
// vero se nessuna carta a terra
bool terravuota(Stato *stato)
{
 return stato->terra.tot == 0;
}
//---------------------------------------------------------------------------
// valore euristico relativo ai punti potenzialmente fatti
int eurpunti(int rimaste,int chi,Giocata mossa,Stato *nuovo,Stato *vecchio)
{
 int out = 0,napmia,squadra;
 squadra = getsquadra(chi);
 // carte
 if (pcarte(vecchio))
 	out += nuovo->prese[squadra].tot * 5;
 // punti gia fatti (settebello ad esempio)
 out += nuovo->spunti.punti[squadra]*100;
 // scope (gia contato in punti, punteggio maggiore perche sicura)
 out += nuovo->spunti.scope[squadra]*20;
 // primiera
 if (pprimiera(squadra,vecchio))
  if (valprim[mossa.poggia.valore] >= valprim[CINQUE]) // piu importanti carte >= 5
 	out += contaprim(nuovo->stat[squadra].prim);
  //else                                 // DEB dare importanza solo nei giusti
    //out += contaprim(nuovo->stat[squadra])/2;  // DEB momenti alle <5
 // ori
 if (pori(vecchio))
 	out += nuovo->stat[squadra].nori*20;
 // napula
 napmia =  nuovo->stat[squadra].stanap;
 //napavv =  nuovo->stat[avversario(squadra)].stanap; // DEB che serve?
 if  (pnapula(vecchio))     		// se qualcuno puo ancora fare napula nello
 									// stato reale
  if (napmia >= 3) out += 100*napmia;   	// fatto il punto
  else out += 50*napmia;             	// puo fare il punto

 return out;
}
//---------------------------------------------------------------------------
// bonta statica della giocata (ver 0.02)
int euristica06(int rimaste,int chi,Giocata mossa,Stato *nuovo,Stato *vecchio)
{
 int out = 0,tot,ringiro,squadra,valore;
 Arr11 somme;
 valore = mossa.poggia.valore;

 sommepossibili(&somme, &(nuovo->terra));

 squadra = getsquadra(chi);
 // 100  rappresenta un punto fatto gli altri valori vanno messi di conseguenza

 // punti ****************************
 out += eurpunti( rimaste, chi, mossa, nuovo, vecchio);
 // difesa ***************************

 // taglio
 if (valore == ASSO)
 {
  // DEB non giocare gli assi facilmente
  // DEB tuning dei valori
  // DEB "meglio enculass de jouga n'ass"

  // rischio scopa butto asso
  if (terravuota(vecchio))
   out += 10;  // DEB perdo l'asso: dovrei togliere qualcosa
  // se ho piu' di un asso non mi pesa buttarne uno
  if (nuovo->inmano->quanti[ASSO] > 1)
   out += 5;
  // gioco gli assi piu' facilmente se sono di mazzo
  if (sonodimazzo(squadra,nuovo))
  	out -= 40;
  else
    out -= 190;
 }
  // non rischiare scopa
  // probabilita' di scopa in funzione del numero di carte rimaste
  tot = sommavalori(&(nuovo->terra));
  if (tot<=RE && tot > 0)
  {
   ringiro =                                 // #carte rimaste in giro
    	nuovo->rimaste.arr[tot] -               // a terra o in mano a qualcuno
     nuovo->inmano->quanti[tot] -            // meno quelle che io ho in mano
     nuovo->terra.quanti[tot];               // meno quelle che sono gia a terra
   //meno la carta che penso abbia il mio compagno
   if (soeha(chi,compagno(chi),valore,nuovo) &&
     ringiro>0)
     ringiro--;
   // DEB meno in teoria la carta che penso abbia il precedente
  }
  assert(ringiro>=0); 						//DEB
  // se non ho informazioni su quella carta
  if (tot <= RE && tot > 0 &&            // possibilita di scopa se ci sono
     ringiro>0)                          // ancora carte di quel valore
  {
   if (!so(chi,prossimo(chi),tot,nuovo))
   {
    // non risponde se precedente non ne ha e compagno si (quindi successivo)
    // DEB ad hoc : generalizzare
    if (soeha(chi,compagno(chi),tot,nuovo) &&
       soenonha(chi,precedente(chi),tot,nuovo))
    {
     out -= 100;
    }
    else
    {
     // probabilita (* 100) che il prossimo abbia almeno una carta con valore tot
     // ovvero (1 - probabilita che non ne abbia manco una)
     // M: numero di carte ancora in mano agli avversari; K: numero di carte in mano
     // di quel valore in mano agli avversari; n: numero di carte in mano al
     // giocatore
     out -= ceil(100. *
    	(1 -
  		iper(rimaste - nuovo->inmano->tot,	// M = popolazione
  			ringiro,						// K = num. difettose
    		nuovo->inmano->tot,				// n = campione
    		0)));                           // k = difet. nel campione

    }
   }
   // ho informazioni su quella carta
   else
   // il prossimo ha quella carta sono sicuro della scopa
   if (ha(chi,prossimo(chi),tot,nuovo))  // penso abbia quella carta
    out -= 100;
  }
  // pari i mazzari, dispari i contromazzari
  // DEB differenziare meglio per tipo di carta
  if (sonodimazzo(squadra,nuovo))
  {
   out += contapari(nuovo)*3 - contadispari(nuovo)*3;   // generico
   if (pprimiera(squadra,vecchio))                       // carte importanti
    out += pari(SETTE,nuovo)* 10;
   if (pnapula(vecchio))    // DEB non basta: se tre gia preso?
    out += pari(TRE,nuovo)* 10  + pari(DUE,nuovo)* 10 ;

   if (pprimiera(squadra,vecchio))                       // carte importanti
    out -= odd(SETTE,nuovo)* 10;
   if (pnapula(vecchio))    // DEB non basta: se tre gia preso?
    out -= odd(TRE,nuovo)* 10  + odd(DUE,nuovo)* 10 ;
  }
  else
  {
   out += contadispari(nuovo)*3 - contapari(nuovo)*3;   // generico
    if (pprimiera(squadra,vecchio))                       // carte importanti
     out -= pari(SETTE,nuovo)* 10;
    if (pnapula(vecchio))    // DEB non basta: se tre gia preso?
     out -= pari(TRE,nuovo)* 10  + pari(DUE,nuovo)* 10 ;

    if (pprimiera(squadra,vecchio))                       // carte importanti
     out += odd(SETTE,nuovo)* 10;
    if (pnapula(vecchio))    // DEB non basta: se tre gia preso?
     out += odd(TRE,nuovo)* 10  + odd(DUE,nuovo)* 10 ;
  }

  //se ballo
  if (mossa.prendi.tot == 0)
  {
   // non ballare inutilmente carte importanti
   if ((mossa.poggia.seme == BELLO) && pori(nuovo)) // se carta bella
    out -= 15;
   if ((mossa.poggia.valore <= TRE) &&    		   // se permette la napula
  		pnapula(vecchio) &&                		   // la napula e fattibile
        ingioco(valore,BELLO,nuovo)&& // la carta e ancora in gioco
        (!nuovo->inmano->info[valore][BELLO].edentro)) //io inmano
     out -= 20;
   // DEB importante la carta immediatamente successiva all'ultima di napula
   // DEB fatta dagli avversari ES hanno sino al tre cerco di prendere il quattro
   // DEB non capisco se importa il fatto che la
   // DEB napula la stanno facendo gli avversari o io
   if (fnapula(squadra,nuovo) &&          // anche  4,5..  se la napula gia fatta
      ingioco(valore,BELLO,nuovo)&& // la carta e ancora in gioco
      (!nuovo->inmano->info[valore][BELLO].edentro)) //non l'ho io
     out -= 100;
   if (valprim[valore] >  			   // se aiuta la primiera
      valprim[nuovo->stat[squadra].prim[mossa.poggia.seme]])
   out -= valprim[valore];

   // butto carte di cui ho quella di denari
   if (nuovo->inmano->info[valore][BELLO].edentro)
      out += 10;
  }

  //non lasciare somme di sette
  // DEB se sette in giro
   if (somme.arr[SETTE])
   {
    out -= 30;
    if (so(chi,prossimo(chi),SETTE,nuovo))
    // se ha il sette meglio non lasciarglielo a terra
    // DEB ci sono una marea di eccezioni:
    // DEB gli lascio sette a terra in modo che debba pagarlo con la scopa
    if (ha(chi,prossimo(chi),SETTE,nuovo))
     out -= 50;
     // se lo ha il mio compagno meglio mettere nei guai il prossimo
    else if (soeha(chi,prossimo(chi),SETTE,nuovo))
              out += 40;
  }

  if (mossa.prendi.tot > 0)          // se prendo
  {
   if (pnapula(nuovo) && !fnapula(squadra,nuovo) && // napula fattibile & non fatta
  	  ((mossa.prendi.quanti[TRE] > 0)              // prendi carte minori di tre
       || (mossa.prendi.quanti[DUE] > 0))
       )
      out += 60;
  }


 return out;
}
//---------------------------------------------------------------------------
// Sceglie la giocata ad euristica maggiore
// prof: profondita' attuale DEB per ora fa un solo passo
// rimaste: numero totale di carte in mano ai giocatori
// chi: chi gioca in questo momento
// squadra: a quale squadra appartiene chi
// Stato: stato di gioco
Risultato scopaduro06(int prof,int rimaste,int chi, int squadra ,Stato stato)
{
 Risultato ris_succ;

 Stato nuovostato;
 Gruppo inmano;
 AGiocata tutteprese;
 int i,ibest,valore;

 // prevede carte degli avversari
 previsioni06(chi,&stato);
 // tutte le possibili giocate
 ognigiocata(&tutteprese,&stato);

 // sceglie la presa con euristica migliore
 ris_succ.valore = -1000;
 //printf(" car val    Primi Ori carte scope pun pa di o n c\n");  //DEB
 for(i = 0; i<tutteprese.pos; i++)
 {
  // crea lo stato futuro in funzione della carta giocata
  nuovostato = stato;
  inmano = *stato.inmano ;
  nuovostato.inmano = &inmano;
  // va al prossimo stato 
  cambiastato(chi, 40-rimaste,tutteprese.arr[i],&inmano,&nuovostato);
  contapunti(&nuovostato);
  // se ho trovato una mossa migliore
  if ((valore = euristica06(rimaste,chi,tutteprese.arr[i],&nuovostato,&stato)) >
  				ris_succ.valore)
  {
    ibest = i;                 // memorizza mossa migliore
    ris_succ.valore = valore;
  }
  //visueuristica(valore,squadra,tutteprese.arr[i],nuovostato); //DEB
 }

 ris_succ.mossa = tutteprese.arr[ibest];
 return ris_succ;
}